package arbre_ini;

/**
 * 
 * @author santini
 * 
 * Définition et gestion d'un noeud feuille.
 *
 */
public class NoeudFeuille extends Noeud implements Observateur {
	
	/**
	 * Constructeur champ à champ.
	 * @param n le nom du noeud feuille.
	 * @param v la valeur du noeud feuille.
	 * @param c le coefficient du noeud feuille.
	 * @param s le noeud parent auquel le noeud feuille s'abonne pour être notifié de ses changements d'état.
	 */
	public NoeudFeuille(String n, Integer v, Integer c, Sujet s) {
		super(n, v, c);
		s.ajouterObservateur(this);
	}
	
	@Override
	/**
	 * Actualise le noeud feuille lorsque Sujet s change d'état.
	 * @param s le noeud parent auquel le noeud feuille s'est abonné pour être notifié de ses changements d'état.
	 */
	public void actualiser(Sujet s) {
		if (s instanceof NoeudRacine) {
			this.majValeur(((NoeudRacine)s).getValeur());
		}
		
	}
	
}
